PROGRAM Compute_PkDT
  USE cosmo
  USE growth
  USE linearpk
  ! A sample program for computing the non-linear power spectrum
  ! of density-velocity cross correlation. 
  ! - k is in units of h Mpc^-1
  ! - P(k) is in units of h^-3 Mpc^3
  ! August 23, 2008: E.Komatsu
  IMPLICIT none
  integer :: j
  double precision :: g,z,D
  double precision :: ak,p11,p22,p13,dlnk,lnk,zin
  external g
  character(len=128) :: filename
  integer :: n
! Specify three cosmological parameters in double precision
! The data type has been defined in MODULE cosmo.
  ode0=0.723d0
  om0=0.277d0
  w=-1d0
! tabulate g(z) by calling "setup_growth"
  call setup_growth
! read in and tabulate P(k)
  filename='wmap5baosn_max_likelihood_matterpower_at_z=30.dat'
  n=896 ! # of lines in the file
  zin=30d0
  CALL open_linearpk(filename,n)
! ask for redshift
  print*,'redshift?'
  read*,z
  D=g(z)/g(zin)*(1d0+zin)/(1d0+z) ! growth relative to z=zin
! now output P_dt(k,z) as a function of k
  open(1,file='wavenumber_pkdt_p11.txt')
  ak=4d-3
  dlnk=1d-2
  do while (ak<0.45d0)
     CALL pkdt(ak,p11,p22,p13)
     write(1,'(3E18.8)')ak,D**2d0*p11+D**4d0*(p22+2d0*p13),D**2d0*p11
     lnk=dlog(ak)+dlnk
     ak=dexp(lnk)
  enddo
  dlnk=1d-1
  do while (ak<15d0)
     CALL pkdt(ak,p11,p22,p13)
     write(1,'(3E18.8)')ak,D**2d0*p11+D**4d0*(p22+2d0*p13),D**2d0*p11
     lnk=dlog(ak)+dlnk
     ak=dexp(lnk)
  enddo
  close(1)
  CALL close_linearpk
END PROGRAM Compute_PkDT
